export * from './util';
type TYPE_T = 1 | 2 | 4 | 8 | 16 | 32 | 64 | 128 | 256 | 512 | 1024;
export declare const Self = -1;
export declare const optional = 1;
export declare const boolean = 2;
export declare const number = 4;
export declare const string = 8;
export declare const integer = 16;
export declare const Null = 32;
export declare const Undefined = 64;
export declare const array = 128;
export declare const object = 256;
export declare const func = 512;
export declare const promise = 1024;
export declare const isOptional: () => boolean;
export declare const isArrayElement: () => boolean;
type FixedArrayElementType = {
    type: string;
    args: Array<any>;
};
export declare const isFixedArrayElement: (...args: Array<any>) => () => FixedArrayElementType;
export declare const composeTypeToArray: (_composeNumber: number) => TYPE_T[];
type ListError = {
    key?: string;
    message: string;
};
export declare class Type {
    schema: any;
    listError: ListError[];
    constructor(_schema: any);
    validateRecusive(valueParam: any, typeParam: any, keyParam?: string, wrapperObject?: any): void;
    validate(value: any): ListError[];
    check(value: any): boolean;
    assert(value: any): void;
}
export default Type;
